<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: exampleTracking.cpp</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_developer.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For C++ developers</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('exampleTracking_8cpp-example.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">exampleTracking.cpp</div>  </div>
</div><!--header-->
<div class="contents">
<p>This is a simple example of how to use a MocoStateTrackingGoal.</p>
<div class="fragment"><div class="line"><span class="comment">/* -------------------------------------------------------------------------- *</span></div>
<div class="line"><span class="comment"> * OpenSim Moco: exampleTracking.cpp                                          *</span></div>
<div class="line"><span class="comment"> * -------------------------------------------------------------------------- *</span></div>
<div class="line"><span class="comment"> * Copyright (c) 2017 Stanford University and the Authors                     *</span></div>
<div class="line"><span class="comment"> *                                                                            *</span></div>
<div class="line"><span class="comment"> * Author(s): Christopher Dembia                                              *</span></div>
<div class="line"><span class="comment"> *                                                                            *</span></div>
<div class="line"><span class="comment"> * Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may    *</span></div>
<div class="line"><span class="comment"> * not use this file except in compliance with the License. You may obtain a  *</span></div>
<div class="line"><span class="comment"> * copy of the License at http://www.apache.org/licenses/LICENSE-2.0          *</span></div>
<div class="line"><span class="comment"> *                                                                            *</span></div>
<div class="line"><span class="comment"> * Unless required by applicable law or agreed to in writing, software        *</span></div>
<div class="line"><span class="comment"> * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,          *</span></div>
<div class="line"><span class="comment"> * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   *</span></div>
<div class="line"><span class="comment"> * See the License for the specific language governing permissions and        *</span></div>
<div class="line"><span class="comment"> * limitations under the License.                                             *</span></div>
<div class="line"><span class="comment"> * -------------------------------------------------------------------------- */</span></div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line"><span class="preprocessor">#include &lt;OpenSim/Simulation/SimbodyEngine/PinJoint.h&gt;</span></div>
<div class="line"><span class="preprocessor">#include &lt;OpenSim/Actuators/CoordinateActuator.h&gt;</span></div>
<div class="line"><span class="preprocessor">#include &lt;OpenSim/Moco/osimMoco.h&gt;</span></div>
<div class="line"> </div>
<div class="line"><span class="keyword">using namespace </span><a class="code" href="namespaceOpenSim.html">OpenSim</a>;</div>
<div class="line"> </div>
<div class="line">std::unique_ptr&lt;Model&gt; createDoublePendulumModel() {</div>
<div class="line">    <span class="comment">// This function is similar to ModelFactory::createNLinkPendulum().</span></div>
<div class="line"> </div>
<div class="line">    <span class="keyword">auto</span> model = make_unique&lt;Model&gt;();</div>
<div class="line">    model-&gt;setName(<span class="stringliteral">&quot;double_pendulum&quot;</span>);</div>
<div class="line"> </div>
<div class="line">    <span class="keyword">using</span> SimTK::Vec3;</div>
<div class="line">    <span class="keyword">using</span> SimTK::Inertia;</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Create two links, each with a mass of 1 kg, center of mass at the body&#39;s</span></div>
<div class="line">    <span class="comment">// origin, and moments and products of inertia of zero.</span></div>
<div class="line">    <span class="keyword">auto</span>* b0 = <span class="keyword">new</span> <a name="_a0"></a><a class="code" href="classOpenSim_1_1Body.html">OpenSim::Body</a>(<span class="stringliteral">&quot;b0&quot;</span>, 1, Vec3(0), Inertia(1));</div>
<div class="line">    model-&gt;addBody(b0);</div>
<div class="line">    <span class="keyword">auto</span>* b1 = <span class="keyword">new</span> <a class="code" href="classOpenSim_1_1Body.html">OpenSim::Body</a>(<span class="stringliteral">&quot;b1&quot;</span>, 1, Vec3(0), Inertia(1));</div>
<div class="line">    model-&gt;addBody(b1);</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Add markers to body origin locations</span></div>
<div class="line">    <span class="keyword">auto</span>* m0 = <span class="keyword">new</span> Marker(<span class="stringliteral">&quot;m0&quot;</span>, *b0, Vec3(0));</div>
<div class="line">    <span class="keyword">auto</span>* m1 = <span class="keyword">new</span> Marker(<span class="stringliteral">&quot;m1&quot;</span>, *b1, Vec3(0));</div>
<div class="line">    model-&gt;addMarker(m0);</div>
<div class="line">    model-&gt;addMarker(m1);</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Connect the bodies with pin joints. Assume each body is 1 m long.</span></div>
<div class="line">    <span class="keyword">auto</span>* j0 = <span class="keyword">new</span> PinJoint(<span class="stringliteral">&quot;j0&quot;</span>, model-&gt;getGround(), Vec3(0), Vec3(0),</div>
<div class="line">            *b0, Vec3(-1, 0, 0), Vec3(0));</div>
<div class="line">    <span class="keyword">auto</span>&amp; q0 = j0-&gt;updCoordinate();</div>
<div class="line">    q0.setRangeMin(-10);</div>
<div class="line">    q0.setRangeMax(10);</div>
<div class="line">    q0.setName(<span class="stringliteral">&quot;q0&quot;</span>);</div>
<div class="line">    <span class="keyword">auto</span>* j1 = <span class="keyword">new</span> PinJoint(<span class="stringliteral">&quot;j1&quot;</span>,</div>
<div class="line">            *b0, Vec3(0), Vec3(0), *b1, Vec3(-1, 0, 0), Vec3(0));</div>
<div class="line">    <span class="keyword">auto</span>&amp; q1 = j1-&gt;updCoordinate();</div>
<div class="line">    q1.setRangeMin(-10);</div>
<div class="line">    q1.setRangeMax(10);</div>
<div class="line">    q1.setName(<span class="stringliteral">&quot;q1&quot;</span>);</div>
<div class="line">    model-&gt;addJoint(j0);</div>
<div class="line">    model-&gt;addJoint(j1);</div>
<div class="line"> </div>
<div class="line">    <span class="keyword">auto</span>* tau0 = <span class="keyword">new</span> CoordinateActuator();</div>
<div class="line">    tau0-&gt;setCoordinate(&amp;j0-&gt;updCoordinate());</div>
<div class="line">    tau0-&gt;setName(<span class="stringliteral">&quot;tau0&quot;</span>);</div>
<div class="line">    tau0-&gt;setOptimalForce(1);</div>
<div class="line">    tau0-&gt;setMinControl(-40);</div>
<div class="line">    tau0-&gt;setMaxControl(40);</div>
<div class="line">    model-&gt;addForce(tau0);</div>
<div class="line"> </div>
<div class="line">    <span class="keyword">auto</span>* tau1 = <span class="keyword">new</span> CoordinateActuator();</div>
<div class="line">    tau1-&gt;setCoordinate(&amp;j1-&gt;updCoordinate());</div>
<div class="line">    tau1-&gt;setName(<span class="stringliteral">&quot;tau1&quot;</span>);</div>
<div class="line">    tau1-&gt;setOptimalForce(1);</div>
<div class="line">    tau1-&gt;setMinControl(-40);</div>
<div class="line">    tau1-&gt;setMaxControl(40);</div>
<div class="line">    model-&gt;addForce(tau1);</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Add display geometry.</span></div>
<div class="line">    SimTK::Transform transform(SimTK::Vec3(-0.5, 0, 0));</div>
<div class="line">    <span class="keyword">auto</span>* b0Center = <span class="keyword">new</span> PhysicalOffsetFrame(<span class="stringliteral">&quot;b0_center&quot;</span>, *b0, transform);</div>
<div class="line">    b0-&gt;addComponent(b0Center);</div>
<div class="line">    b0Center-&gt;attachGeometry(<span class="keyword">new</span> Ellipsoid(0.5, 0.1, 0.1));</div>
<div class="line">    <span class="keyword">auto</span>* b1Center = <span class="keyword">new</span> PhysicalOffsetFrame(<span class="stringliteral">&quot;b1_center&quot;</span>, *b1, transform);</div>
<div class="line">    b1-&gt;addComponent(b1Center);</div>
<div class="line">    b1Center-&gt;attachGeometry(<span class="keyword">new</span> Ellipsoid(0.5, 0.1, 0.1));</div>
<div class="line"> </div>
<div class="line">    model-&gt;finalizeConnections();</div>
<div class="line"> </div>
<div class="line">    <span class="keywordflow">return</span> model;</div>
<div class="line">}</div>
<div class="line"> </div>
<div class="line"><span class="keywordtype">int</span> main() {</div>
<div class="line"> </div>
<div class="line">    MocoStudy study;</div>
<div class="line">    study.setName(<span class="stringliteral">&quot;double_pendulum_tracking&quot;</span>);</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Define the optimal control problem.</span></div>
<div class="line">    <span class="comment">// ===================================</span></div>
<div class="line">    MocoProblem&amp; problem = study.updProblem();</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Model (dynamics).</span></div>
<div class="line">    <span class="comment">// -----------------</span></div>
<div class="line">    problem.setModel(createDoublePendulumModel());</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Bounds.</span></div>
<div class="line">    <span class="comment">// -------</span></div>
<div class="line">    <span class="keywordtype">double</span> finalTime = 1.0;</div>
<div class="line">    problem.setTimeBounds(0, finalTime);</div>
<div class="line">    problem.setStateInfo(<span class="stringliteral">&quot;/jointset/j0/q0/value&quot;</span>, {-10, 10});</div>
<div class="line">    problem.setStateInfo(<span class="stringliteral">&quot;/jointset/j0/q0/speed&quot;</span>, {-50, 50});</div>
<div class="line">    problem.setStateInfo(<span class="stringliteral">&quot;/jointset/j1/q1/value&quot;</span>, {-10, 10});</div>
<div class="line">    problem.setStateInfo(<span class="stringliteral">&quot;/jointset/j1/q1/speed&quot;</span>, {-50, 50});</div>
<div class="line">    problem.setControlInfo(<span class="stringliteral">&quot;/forceset/tau0&quot;</span>, {-40, 40});</div>
<div class="line">    problem.setControlInfo(<span class="stringliteral">&quot;/forceset/tau1&quot;</span>, {-40, 40});</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Cost.</span></div>
<div class="line">    <span class="comment">// -----</span></div>
<div class="line">    <span class="keyword">auto</span>* tracking = problem.addGoal&lt;MocoStateTrackingGoal&gt;(<span class="stringliteral">&quot;tracking&quot;</span>);</div>
<div class="line">    <a name="a1"></a><a class="code" href="namespaceOpenSim.html#a39e2414750443cfa41c224f5cdd31bac">TimeSeriesTable</a> ref;</div>
<div class="line">    ref.<a name="a2"></a><a class="code" href="classOpenSim_1_1AbstractDataTable.html#a519ebcb3d6706224c0c267f018c99a7e">addTableMetaData</a>&lt;std::string&gt;(<span class="stringliteral">&quot;inDegrees&quot;</span>, <span class="stringliteral">&quot;no&quot;</span>);</div>
<div class="line">    ref.setColumnLabels({<span class="stringliteral">&quot;/jointset/j0/q0/value&quot;</span>, <span class="stringliteral">&quot;/jointset/j1/q1/value&quot;</span>});</div>
<div class="line">    <span class="comment">// We supply a reference whose time range is a superset of the problem&#39;s</span></div>
<div class="line">    <span class="comment">// time bounds: Moco performs finite differences internally, which may</span></div>
<div class="line">    <span class="comment">// require sampling outside the problem&#39;s time bounds.</span></div>
<div class="line">    <span class="keywordflow">for</span> (<span class="keywordtype">double</span> time = -0.05; time &lt; finalTime + 0.05; time += 0.01) {</div>
<div class="line">        ref.appendRow(time, {</div>
<div class="line">                0.5 * SimTK::Pi * time,</div>
<div class="line">                0.25 * SimTK::Pi * time</div>
<div class="line">        });</div>
<div class="line">    }</div>
<div class="line"> </div>
<div class="line">    tracking-&gt;setReference(ref);</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// A low-weighted cost term minimizing controls helps with convergence.</span></div>
<div class="line">    problem.addGoal&lt;MocoControlGoal&gt;(<span class="stringliteral">&quot;effort&quot;</span>, 0.001);</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Configure the solver.</span></div>
<div class="line">    <span class="comment">// =====================</span></div>
<div class="line">    <span class="keyword">auto</span>&amp; solver = study.initCasADiSolver();</div>
<div class="line">    solver.set_num_mesh_intervals(50);</div>
<div class="line">    solver.set_verbosity(2);</div>
<div class="line">    solver.set_optim_solver(<span class="stringliteral">&quot;ipopt&quot;</span>);</div>
<div class="line"> </div>
<div class="line">    study.print(<span class="stringliteral">&quot;double_pendulum_tracking.omoco&quot;</span>);</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Solve the problem.</span></div>
<div class="line">    <span class="comment">// ==================</span></div>
<div class="line">    MocoSolution solution = study.solve();</div>
<div class="line">    solution.write(<span class="stringliteral">&quot;exampleTracking_solution.sto&quot;</span>);</div>
<div class="line"> </div>
<div class="line">    study.visualize(solution);</div>
<div class="line"> </div>
<div class="line">    <span class="keywordflow">return</span> EXIT_SUCCESS;</div>
<div class="line">}</div>
<div class="ttc" id="aclassOpenSim_1_1AbstractDataTable_html_a519ebcb3d6706224c0c267f018c99a7e"><div class="ttname"><a href="classOpenSim_1_1AbstractDataTable.html#a519ebcb3d6706224c0c267f018c99a7e">OpenSim::AbstractDataTable::addTableMetaData</a></div><div class="ttdeci">void addTableMetaData(const std::string &amp;key, const Value &amp;value)</div><div class="ttdoc">Add key-value pair to the table metadata.</div><div class="ttdef"><b>Definition:</b> AbstractDataTable.h:220</div></div>
<div class="ttc" id="aclassOpenSim_1_1Body_html"><div class="ttname"><a href="classOpenSim_1_1Body.html">OpenSim::Body</a></div><div class="ttdoc">An OpenSim::Body is a PhysicalFrame (reference frame) with associated inertia specified by its mass,...</div><div class="ttdef"><b>Definition:</b> Body.h:42</div></div>
<div class="ttc" id="anamespaceOpenSim_html"><div class="ttname"><a href="namespaceOpenSim.html">OpenSim</a></div><div class="ttdoc">The Moco interface is contained within the OpenSim namespace.</div><div class="ttdef"><b>Definition:</b> ActivationCoordinateActuator.h:30</div></div>
<div class="ttc" id="anamespaceOpenSim_html_a39e2414750443cfa41c224f5cdd31bac"><div class="ttname"><a href="namespaceOpenSim.html#a39e2414750443cfa41c224f5cdd31bac">OpenSim::TimeSeriesTable</a></div><div class="ttdeci">TimeSeriesTable_&lt; SimTK::Real &gt; TimeSeriesTable</div><div class="ttdoc">See TimeSeriesTable_ for details on the interface.</div><div class="ttdef"><b>Definition:</b> TimeSeriesTable.h:519</div></div>
</div><!-- fragment --> </div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:01 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
